;;--------------------------------------
;;  Tento program testuje vysilani
;;    infra-diodou (pomoci PWM)
;; RB0 - svitici LED dioda
;; RB7 - optoprijimac SFH-506
;; RD0 - tlacitko
;; RC2 - infra-dioda (PWM signal)
;;--------------------------------------

	LIST	P = 16F877, R = DEC
	include	p16f877.inc

	__CONFIG	H'3F72'

;--------------------------------------

	ORG      0
	NOP
	NOP
	NOP
	CLRF	PORTB
	CLRF	PORTD
	banksel	TRISB
	MOVLW	B'11111110'
	MOVWF	TRISB
	BCF	TRISC,2
	MOVLW	B'00001111'
	MOVWF	TRISD
	banksel	T2CON
	MOVLW	B'00000100'
	MOVWF	T2CON
	banksel	PR2
	MOVLW	D'127'	; perioda TMR2 odpovida asi 39KHz
	MOVWF	PR2
	MOVLW	B'00000000'
	MOVWF	OPTION_REG
	banksel	0
	CLRF	TMR2
	CLRF	CCPR1L
	MOVLW	B'00001100' ; aktivace PWM (39KHz)
	MOVWF	CCP1CON

LOOP	BTFSS	PORTD,0	; detekce tlacitka je prevedena...
	BSF	CCPR1L,6	; ...na aktivaci stridy PWM pro...
	BTFSC	PORTD,0	; ...infra-diodu
	BCF	CCPR1L,6
	BTFSS	PORTB,7	; detekce signalu z SFH-506 je prevedena...
	BSF	PORTB,0	; ...na svit LED-diody
	BTFSC	PORTB,7
	BCF	PORTB,0
	GOTO	LOOP

	END
