;--------------------------------------
; GENEROVANI ZVUKU POMOCI SOFTWAROVEHO
; GENERATORU V OBSLUZE PRERUSENI
; 16bitova perioda + 8bitova amplituda
;--------------------------------------
	LIST	P = 16F877, R = DEC
	include	p16f877.inc

	__CONFIG	H'3F72'

;--------------------------------------

FAZE	EQU	D'0'	; bit indikujici fazy

OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"
TEMPRAM	EQU	H'70'	; posledni blok pameti (16 bytu)
			; - je zrcadlen do vsech pametovych bank 

	CBLOCK	OFFRAM
	PERIOD:2	; zpracovavana perioda
	PERIOD_:2	; nastavena perioda
	AMPLIT_:1	; nastavena amplituda
	ZSTATUS:1	; obsahuje fazy
	ZVUK:1	; genrovany zvuk
	ZVUK_:1	; pomocna promena

	DELAY_:2	; pomocna zpozdovaci promenna
	TEMP:2	; pomocna dekrementacni promena
	ENDC

	CBLOCK	TEMPRAM	; zalozni registry, ktere
	W_TEMP:1		; jsou nezavisle na zvolene
	ST_TEMP:1		; pametove bance !!!
	ENDC



;--------------------------------------

	ORG      0
	NOP
	NOP
	NOP
	GOTO     START

	ORG	4
	MOVWF	W_TEMP
	MOVF	STATUS,W
	MOVWF	ST_TEMP
	banksel	0
	BCF	PIR1,TMR2IF ; odstraneni priznaku od TMR2
	MOVF	ZVUK,W	; preneseni zvukoveho vzorku do docasne promenne
	MOVWF	ZVUK_
	RRF	ZVUK_,F	; nastaveni stridy pomoci teto docasne promenne
	BCF	CCP1CON,CCP1Y
	BTFSC	STATUS,C
	BSF	CCP1CON,CCP1Y
	RRF	ZVUK_,W
	BCF	CCP1CON,CCP1X
	BTFSC	STATUS,C
	BSF	CCP1CON,CCP1X
	ANDLW	B'00111111'
	MOVWF	CCPR1L	; strida nastavena

	DECF	PERIOD+1,F
	INCFSZ	PERIOD+1,W ; cekani na podteceni PERIODy
	GOTO	INT_END
	MOVF	PERIOD_+0,W ; nastradani nizsiho bytu pro pristi volani
	ADDWF	PERIOD+0,F
	MOVF	PERIOD_+1,W
	BTFSC	STATUS,C
	INCFSZ	PERIOD_+1,W ; pokud nizsi byte pretekl, musime upravit vyssi byte
	ADDWF	PERIOD+1,F
	MOVLW	B'00000001'
	XORWF	ZSTATUS,F	; zmena faze
	MOVF	AMPLIT_,W	; (nastavena amplituda)
	BTFSS	ZSTATUS,FAZE
	MOVLW	D'0'
	MOVWF	ZVUK	; urceni noveho zvukoveho vzorku
INT_END	MOVF	ST_TEMP,W	; ukonceni obsluhy preruseni
	MOVWF	STATUS
	SWAPF	W_TEMP,F
	SWAPF	W_TEMP,W
	RETFIE  


START	
	banksel	TRISC	; nastavime RC2 jako vystup (pro PWM)
	BCF	TRISC,2
	banksel	T1CON
	MOVLW	B'00011100' ; TMR2 vyvola preruseni kazdou ctvrtou periodu
	MOVWF	T2CON
	banksel	PR2
	MOVLW	D'63'	; perioda TMR2 = 64 instrukcnich cyklu
	MOVWF	PR2
	banksel	0

	CLRF	TMR2
	CLRF	CCPR1L	; aktivace a vynulovani PWM
	MOVLW	B'00001100'
	MOVWF	CCP1CON

	MOVLW	D'255'	; "nulove" nastaveni generatoru
	MOVWF	PERIOD_+0
	MOVWF	PERIOD_+1
	CLRF	AMPLIT_

	banksel	PIE1	; aktivace preruseni od TMR2
	BSF	PIE1,TMR2IE
	banksel	0
	BSF	INTCON,PEIE
	BSF	INTCON,GIE

LOOP	
	MOVLW	D'255'	; generovani posloupnosti period/frekvenci...
	MOVWF	TEMP+1	; ...pomoci cyklu LOOP2
	MOVLW	D'255'
	MOVWF	TEMP+0
LOOP2	MOVF	TEMP+1,W
	MOVWF	PERIOD_+1
	MOVF	TEMP+0,W
	MOVWF	PERIOD_+0
	MOVLW	D'255'
	MOVWF	AMPLIT_
	MOVLW	D'2'
	CALL	DELAY
	DECFSZ	TEMP+0,F
	GOTO	LOOP2
	DECFSZ	TEMP+1,F
	GOTO	LOOP2

	MOVLW	D'127'	; generovani utlumu amplitudy...
	MOVWF	TEMP	; ...pomoci cyklu LOOP3
LOOP3	MOVLW	D'10'
	MOVWF	PERIOD_+1
	CLRF	PERIOD_+0
	RLF	TEMP,W
	MOVWF	AMPLIT_
	MOVLW	D'255'
	CALL	DELAY
	DECFSZ	TEMP,F
	GOTO	LOOP3

	GOTO	LOOP

DELAY	MOVWF	DELAY_+1	; jednoduche zpozdeni
	CLRF	DELAY_+0
	DECFSZ	DELAY_+0,F
	GOTO	$ - 1
	DECFSZ	DELAY_+1,F
	GOTO	$ - 3
	RETURN


	END
