;--------------------------------------
; GENEROVANI ZVUKU POMOCI SOFTWAROVEHO
; GENERATORU V OBSLUZE PRERUSENI
; 16bitova perioda + 16bitova amplituda
; + 16bitovy dozvuk
;--------------------------------------
	LIST	P = 16F877, R = DEC
	include	p16f877.inc

	__CONFIG	H'3F72'

;--------------------------------------

FAZE	EQU	D'0'	; bit indikujici fazy zvuku
AKTIVNI	EQU	D'1'	; bit indikujici aktivitu kanalu

OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"
TEMPRAM	EQU	H'70'	; posledni blok pameti (16 bytu)
			; - je zrcadlen do vsech pametovych bank 

	CBLOCK	OFFRAM
	PERIOD:2	; zpracovavana perioda
	PERIOD_:2	; nastavena perioda
	DOZVUK_:2	; nastaveny dozvuk
	AMPLIT:2	; aktualni amplituda
	ZSTATUS:1	; obsahuje fazy
	ZVUK:1	; genrovany zvuk
	ZVUK_:1	; pomocna promena
	COUNTER:1	; citac cyklu dozvuku

	DELAY_:3	; pomocna zpozdovaci promenna
	ENDC

	CBLOCK	TEMPRAM	; zalozni registry, ktere
	W_TEMP:1		; jsou nezavisle na zvolene
	ST_TEMP:1		; pametove bance !!!
	ENDC



;--------------------------------------

	ORG      0
	NOP
	NOP
	NOP
	GOTO     START

	ORG	4
	MOVWF	W_TEMP
	MOVF	STATUS,W
	MOVWF	ST_TEMP
	banksel	0
	BCF	PIR1,TMR2IF ; odstraneni priznaku od TMR2
	MOVF	ZVUK,W	; preneseni zvukoveho vzorku do docasne promenne
	MOVWF	ZVUK_
	RRF	ZVUK_,F	; nastaveni stridy pomoci teto docasne promenne
	BCF	CCP1CON,CCP1Y
	BTFSC	STATUS,C
	BSF	CCP1CON,CCP1Y
	RRF	ZVUK_,W
	BCF	CCP1CON,CCP1X
	BTFSC	STATUS,C
	BSF	CCP1CON,CCP1X
	ANDLW	B'00111111'
	MOVWF	CCPR1L	; strida nastavena

	BTFSS	ZSTATUS,AKTIVNI ; je kanal aktivni?
	GOTO	INT_END
	DECF	PERIOD+1,F
	INCFSZ	PERIOD+1,W ; probiha zparacovani periody
	GOTO	POPERI
	MOVF	PERIOD_+0,W
	ADDWF	PERIOD+0,F
	MOVF	PERIOD_+1,W
	BTFSC	STATUS,C
	INCFSZ	PERIOD_+1,W
	ADDWF	PERIOD+1,F
	MOVLW	B'00000001'
	XORWF	ZSTATUS,F
POPERI	MOVF	AMPLIT+1,W ; nastaveni aktualniho zvukoveho vzorku
	BTFSS	ZSTATUS,FAZE
	MOVLW	D'0'
	MOVWF	ZVUK
	DECFSZ	COUNTER,F ; v kazdem 64. cyklu provedeme upravu amplitudy
	GOTO	INT_END
	MOVLW	D'64'
	MOVWF	COUNTER
	MOVF	DOZVUK_+0,W ; jednoduse snizime amplitudu o DOZVUK
	SUBWF	AMPLIT+0,F
	MOVF	DOZVUK_+1,W
	BTFSS	STATUS,C
	INCFSZ	DOZVUK_+1,W
	SUBWF	AMPLIT+1,F
	BTFSS	STATUS,C	; doslo-li k podteceni, amlituda je navzdy nulova...
	BCF	ZSTATUS,AKTIVNI ; ...(deaktivace kanalu)
INT_END	MOVF	ST_TEMP,W	; ukonceni obsluhy preruseni
	MOVWF	STATUS
	SWAPF	W_TEMP,F
	SWAPF	W_TEMP,W
	RETFIE  


START	
	banksel	TRISC	; nastavime RC2 jako vystup (pro PWM)
	BCF	TRISC,2
	banksel	T1CON
	MOVLW	B'00011100' ; TMR2 vyvola preruseni kazdou ctvrtou periodu
	MOVWF	T2CON
	banksel	PR2
	MOVLW	D'63'	; perioda TMR2 = 64 instrukcnich cyklu
	MOVWF	PR2
	banksel	0

	CLRF	TMR2
	CLRF	CCPR1L	; aktivace a vynulovani PWM
	MOVLW	B'00001100'
	MOVWF	CCP1CON

	MOVLW	D'255'	; "nulove" nastaveni generatoru
	MOVWF	PERIOD_+0
	MOVWF	PERIOD_+1
	CLRF	AMPLIT+0
	CLRF	AMPLIT+1
	CLRF	DOZVUK_+0
	CLRF	DOZVUK_+1

	banksel	PIE1	; aktivace preruseni od TMR2
	BSF	PIE1,TMR2IE
	banksel	0
	BSF	INTCON,PEIE
	BSF	INTCON,GIE

; toto je pomocne makro pro nastaveni generatoru
DEJTON	macro	PERIODA, HLASITOST, DOZVUK
	MOVLW	PERIODA / H'100'
	MOVWF	PERIOD_ + 1
	MOVLW	PERIODA % H'100'
	MOVWF	PERIOD_ + 0
	MOVLW	DOZVUK / H'100'
	MOVWF	DOZVUK_ + 1
	MOVLW	DOZVUK % H'100'
	MOVWF	DOZVUK_ + 0
	MOVLW	HLASITOST / H'100'
	MOVWF	AMPLIT + 1
	MOVLW	HLASITOST % H'100'
	MOVWF	AMPLIT + 0
	BSF	ZSTATUS,AKTIVNI
	endm

	; demonstracni posloupnost (neladenych) tonu
	DEJTON	D'20000',	D'60000',D'50'
	MOVLW	D'20'
	CALL	DELAYH
	DEJTON	D'10000',	D'60000',D'100'
	MOVLW	D'20'
	CALL	DELAYH
	DEJTON	D'5000',	D'60000',D'200'
	MOVLW	D'20'
	CALL	DELAYH
	DEJTON	D'2500',	D'60000',D'400'
LOOP	GOTO	LOOP

DELAYH	MOVWF	DELAY_+2	; jednoduche zpozdeni...
	CLRF	DELAY_+1	; ..(s dlouhym krokem)
	CLRF	DELAY_+0
	DECFSZ	DELAY_+0,F
	GOTO	$ - 1
	DECFSZ	DELAY_+1,F
	GOTO	$ - 3
	DECFSZ	DELAY_+2,F
	GOTO	$ - 5
	RETURN


	END
