;;------------------------------------------
;;   TENTO PROGRAM DEMONSTRUJE PRACI
;;       SE CTYRMI GENERATORY
;; + implementace exponencialniho dozvuku!
;;------------------------------------------
	LIST	P = 16F877, R = DEC
	include	p16f877.inc

	__CONFIG	H'3F72'

	include	dejton.inc ; makro, ktere usnadnuje nastaveni generatoru

;--------------------------------------

FAZE	EQU	D'0'
AKTIVNI	EQU	D'1'
DOZVUK	EQU	D'2'

OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"
TEMPRAM	EQU	H'70'	; posledni blok pameti (16 bytu)
			; - je zrcadlen do vsech pametovych bank 

	CBLOCK	OFFRAM
	PERIOD1:2		; promenne pro kanal 1
	PERIOD1_:2
	AMPLIT1:2
	DOZVUK1:2
	COUNTER1:1
	ZSTATUS1:1
	ZVUK1:1

	PERIOD2:2		; promenne pro kanal 2
	PERIOD2_:2
	AMPLIT2:2
	DOZVUK2:2
	COUNTER2:1
	ZSTATUS2:1
	ZVUK2:1

	PERIOD3:2		; promenne pro kanal 3
	PERIOD3_:2
	AMPLIT3:2
	DOZVUK3:2
	COUNTER3:1
	ZSTATUS3:1
	ZVUK3:1

	PERIOD4:2		; promenne pro kanal 4
	PERIOD4_:2
	AMPLIT4:2
	DOZVUK4:2
	COUNTER4:1
	ZSTATUS4:1
	ZVUK4:1

	ZVUK:1		; mixovany zvuk

	DELAY_:3		; pomocna zpozdovaci promenna

	WTABTEMP:1	; pomocna adresacni promenna
	ENDC

	CBLOCK	TEMPRAM	; zalozni registry, ktere
	W_TEMP:1		; jsou nezavisle na zvolene
	ST_TEMP:1		; pametove bance !!!
	ENDC



;--------------------------------------

	ORG      0
	NOP
	NOP
	NOP
	GOTO     START

	ORG	4
	MOVWF	W_TEMP	; zaloha registru W,STATUS a FSR
	MOVF	STATUS,W
	MOVWF	ST_TEMP
	banksel	0

	BTFSS	PIR1,TMR2IF
	GOTO	INT_END

ZVUK___	RRF	ZVUK,F	; tentokrat nemusime pouzit pomocnou...
	BCF	CCP1CON,CCP1Y ; promennou ZVUK_, protoze ZVUK se...
	BTFSC	STATUS,C	; ...aktualizuje v kazdem cyklu
	BSF	CCP1CON,CCP1Y
	RRF	ZVUK,W
	BCF	CCP1CON,CCP1X
	BTFSC	STATUS,C
	BSF	CCP1CON,CCP1X
	ANDLW	B'00111111'
	MOVWF	CCPR1L
	BCF	PIR1,TMR2IF
	
	BTFSS	ZSTATUS1,AKTIVNI	; kanal 1
	GOTO	POZVUK1
	DECF	PERIOD1+1,F
	INCF	PERIOD1+1,W
	BTFSS	STATUS,Z
	GOTO	PO_PER1
	MOVF	PERIOD1_+0,W
	ADDWF	PERIOD1+0,F
	MOVF	PERIOD1_+1,W
	BTFSC	STATUS,C
	INCFSZ	PERIOD1_+1,W
	ADDWF	PERIOD1+1,F
	MOVLW	B'00000001'
	XORWF	ZSTATUS1,F
PO_PER1	MOVF	AMPLIT1+1,W
	BTFSS	ZSTATUS1,FAZE
	MOVLW	D'0'
	MOVWF	ZVUK1
	DECFSZ	COUNTER1,F
	GOTO	POZVUK1
	MOVLW	D'64'
	MOVWF	COUNTER1
	BTFSS	ZSTATUS1,DOZVUK	; je aktivni dozvuk ?
	GOTO	POZVUK1
	MOVF	DOZVUK1+0,W
	SUBWF	AMPLIT1+0,F
	MOVF	DOZVUK1+1,W
	BTFSS	STATUS,C
	INCFSZ	DOZVUK1+1,W
	SUBWF	AMPLIT1+1,F
	BTFSS	STATUS,C
	BCF	ZSTATUS1,AKTIVNI
POZVUK1
	BTFSS	ZSTATUS2,AKTIVNI	; kanal 2
	GOTO	POZVUK2
	DECF	PERIOD2+1,F
	INCF	PERIOD2+1,W
	BTFSS	STATUS,Z
	GOTO	PO_PER2
	MOVF	PERIOD2_+0,W
	ADDWF	PERIOD2+0,F
	MOVF	PERIOD2_+1,W
	BTFSC	STATUS,C
	INCFSZ	PERIOD2_+1,W
	ADDWF	PERIOD2+1,F
	MOVLW	B'00000001'
	XORWF	ZSTATUS2,F
PO_PER2	MOVF	AMPLIT2+1,W
	BTFSS	ZSTATUS2,FAZE
	MOVLW	D'0'
	MOVWF	ZVUK2
	DECFSZ	COUNTER2,F
	GOTO	POZVUK2
	MOVLW	D'64'
	MOVWF	COUNTER2
	BTFSS	ZSTATUS2,DOZVUK
	GOTO	POZVUK2
	MOVF	DOZVUK2+0,W
	SUBWF	AMPLIT2+0,F
	MOVF	DOZVUK2+1,W
	BTFSS	STATUS,C
	INCFSZ	DOZVUK2+1,W
	SUBWF	AMPLIT2+1,F
	BTFSS	STATUS,C
	BCF	ZSTATUS2,AKTIVNI
POZVUK2
	BTFSS	ZSTATUS3,AKTIVNI	; kanal 3
	GOTO	POZVUK3
	DECF	PERIOD3+1,F
	INCF	PERIOD3+1,W
	BTFSS	STATUS,Z
	GOTO	PO_PER3
	MOVF	PERIOD3_+0,W
	ADDWF	PERIOD3+0,F
	MOVF	PERIOD3_+1,W
	BTFSC	STATUS,C
	INCFSZ	PERIOD3_+1,W
	ADDWF	PERIOD3+1,F
	MOVLW	B'00000001'
	XORWF	ZSTATUS3,F
PO_PER3	MOVF	AMPLIT3+1,W
	BTFSS	ZSTATUS3,FAZE
	MOVLW	D'0'
	MOVWF	ZVUK3
	DECFSZ	COUNTER3,F
	GOTO	POZVUK3
	MOVLW	D'64'
	MOVWF	COUNTER3
	BTFSS	ZSTATUS3,DOZVUK
	GOTO	POZVUK3
	MOVF	DOZVUK3+0,W
	SUBWF	AMPLIT3+0,F
	MOVF	DOZVUK3+1,W
	BTFSS	STATUS,C
	INCFSZ	DOZVUK3+1,W
	SUBWF	AMPLIT3+1,F
	BTFSS	STATUS,C
	BCF	ZSTATUS3,AKTIVNI
POZVUK3
	BTFSS	ZSTATUS4,AKTIVNI	; kanal 4
	GOTO	POZVUK4
	DECF	PERIOD4+1,F
	INCF	PERIOD4+1,W
	BTFSS	STATUS,Z
	GOTO	PO_PER4
	MOVF	PERIOD4_+0,W
	ADDWF	PERIOD4+0,F
	MOVF	PERIOD4_+1,W
	BTFSC	STATUS,C
	INCFSZ	PERIOD4_+1,W
	ADDWF	PERIOD4+1,F
	MOVLW	B'00000001'
	XORWF	ZSTATUS4,F
PO_PER4	MOVF	AMPLIT4+1,W
	BTFSS	ZSTATUS4,FAZE
	MOVLW	D'0'
	MOVWF	ZVUK4
	DECFSZ	COUNTER4,F
	GOTO	POZVUK4
	MOVLW	D'64'
	MOVWF	COUNTER4
	BTFSS	ZSTATUS4,DOZVUK
	GOTO	POZVUK4
	MOVF	DOZVUK4+0,W
	SUBWF	AMPLIT4+0,F
	MOVF	DOZVUK4+1,W
	BTFSS	STATUS,C
	INCFSZ	DOZVUK4+1,W
	SUBWF	AMPLIT4+1,F
	BTFSS	STATUS,C
	BCF	ZSTATUS4,AKTIVNI
POZVUK4
	; zde jsou kanaly mixovany
	MOVF	ZVUK1,W
	CALL	AMPLITUDA	; prepocet na exponencialni dozvuk/amplitudu
	MOVWF	ZVUK
	MOVF	ZVUK2,W
	CALL	AMPLITUDA
	ADDWF	ZVUK,F	; pripocitavame kanal 2
	MOVLW	D'255'
	BTFSC	STATUS,C	; musime osetrit preteceni (oriznutim)
	MOVWF	ZVUK
	MOVF	ZVUK3,W
	CALL	AMPLITUDA
	ADDWF	ZVUK,F	; pripocitavame kanal 3
	MOVLW	D'255'
	BTFSC	STATUS,C	; musime osetrit preteceni (oriznutim)
	MOVWF	ZVUK
	MOVF	ZVUK4,W
	CALL	AMPLITUDA
	ADDWF	ZVUK,F	; pripocitavame kanal 4
	MOVLW	D'255'
	BTFSC	STATUS,C	; musime osetrit preteceni (oriznutim)
	MOVWF	ZVUK

INT_END	MOVF	ST_TEMP,W
	MOVWF	STATUS
	SWAPF	W_TEMP,F
	SWAPF	W_TEMP,W
	RETFIE 

START
	banksel	TRISC
	BCF	TRISC,2
	banksel	T2CON
	MOVLW	B'00011100'
	MOVWF	T2CON
	banksel	PR2
	MOVLW	D'63'
	MOVWF	PR2
	banksel	0

	CLRF	TMR2
	CLRF	CCPR1L
	MOVLW	B'00001100'
	MOVWF	CCP1CON

	CLRF	ZSTATUS1	; deaktivace generatoru
	CLRF	ZSTATUS2
	CLRF	ZSTATUS3
	CLRF	ZSTATUS4

	banksel	PIE1
	BSF	PIE1,TMR2IE
	banksel	0
	BSF	INTCON,PEIE
	BSF	INTCON,GIE


	; demonstracni posloupnost (neladenych) tonu
	DEJTON	D'20000',	D'65000',D'50',D'1'
	MOVLW	D'20'
	CALL	DELAYH
	DEJTON	D'10000',	D'65000',D'100',D'2'
	MOVLW	D'20'
	CALL	DELAYH
	DEJTON	D'5000',	D'65000',D'200',D'3'
	MOVLW	D'20'
	CALL	DELAYH
	DEJTON	D'2500',	D'65000',D'400',D'4'
	MOVLW	D'40'
	CALL	DELAYH

	; nyni se budou zvuky navic vyrazne prekryvat
	DEJTON	D'20000',	D'60000',D'20',D'1'
	MOVLW	D'20'
	CALL	DELAYH
	DEJTON	D'10000',	D'60000',D'20',D'2'
	MOVLW	D'20'
	CALL	DELAYH
	DEJTON	D'5000',	D'60000',D'20',D'3'
	MOVLW	D'20'
	CALL	DELAYH
	DEJTON	D'2500',	D'60000',D'20',D'4'

LOOP	GOTO	LOOP


DELAYH	MOVWF	DELAY_+2	; jednoduche zpozdeni...
	CLRF	DELAY_+1	; ..(s dlouhym krokem)
	CLRF	DELAY_+0
	DECFSZ	DELAY_+0,F
	GOTO	$ - 1
	DECFSZ	DELAY_+1,F
	GOTO	$ - 3
	DECFSZ	DELAY_+2,F
	GOTO	$ - 5
	RETURN

;---------------------------------------
; amplitudy exponencialniho dozvuku
AMPLITUDA	MOVWF	WTABTEMP	; WTABTEMP predstavuje index radku tabulky
	MOVLW	AMPLDATA / H'100'
	MOVWF	PCLATH
	MOVLW	AMPLDATA % H'100'
	ADDWF	WTABTEMP,W
	BTFSC	STATUS,C
	INCF	PCLATH,F
	MOVWF	PCL
AMPLDATA
	include	ampldata.inc ; zde je obsazena tabulka v podobe "RETLW" instrukci


	END
