;;----------------------------------------
;; TENTO PROGRAM DEMONSTRUJE PREHRAVANI
;; HUDEBNI SKLADBY (MOZART) NA CTYRECH
;; TONOVYCH GENERATORECH
;; - program neni okomentovan, jeho popis
;;   se bude nachazet v pristi lekci
;;   Miniskoly
;;----------------------------------------
	LIST	P = 16F877, R = DEC
	include	p16f877.inc

	__CONFIG	H'3F72'

;--------------------------------------

	include	tab_util.inc
	include	zapisnot.inc
	include	delky.inc
	include	adr_save.inc

; !!! DALE JSOU VYZADOVANY SOUBORY :
;
; !		ampldata.inc
; !		tony.inc
; !		casy.inc
; !		dozvuky.inc
; !		hlasit.inc
; !		mozart.inc

FAZE	EQU	D'0'
AKTIVNI	EQU	D'1'
DOZVUK	EQU	D'2'

OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"
TEMPRAM	EQU	H'70'	; posledni blok pameti (16 bytu)
			; - je zrcadlen do vsech pametovych bank 

	CBLOCK	OFFRAM
	PERIOD1:2
	PERIOD1_:2
	AMPLIT1:2
	DOZVUK1:2
	COUNTER1:1
	ZSTATUS1:1
	ZVUK1:1

	PERIOD2:2
	PERIOD2_:2
	AMPLIT2:2
	DOZVUK2:2
	COUNTER2:1
	ZSTATUS2:1
	ZVUK2:1

	PERIOD3:2
	PERIOD3_:2
	AMPLIT3:2
	DOZVUK3:2
	COUNTER3:1
	ZSTATUS3:1
	ZVUK3:1

	PERIOD4:2
	PERIOD4_:2
	AMPLIT4:2
	DOZVUK4:2
	COUNTER4:1
	ZSTATUS4:1
	ZVUK4:1

	ZVUK:1

	TEMP:2
	DELAY:3
	EADR_TEMP:2
	AKTIV:1
	NEAKTIV:1
	TON_:1
	HLASIT_:1
	DOZVUK_:1

	WTABTEMP:1
	ENDC

	CBLOCK	TEMPRAM	; zalozni registry, ktere
	W_TEMP:1		; jsou nezavisle na zvolene
	ST_TEMP:1		; pametove bance !!!
	FSR_TEMP:1
	ENDC



;--------------------------------------

	ORG      0
	NOP
	NOP
	NOP
	GOTO     START

	ORG	4
	MOVWF	W_TEMP	; zaloha registru W,STATUS a FSR
	MOVF	STATUS,W
	MOVWF	ST_TEMP
	banksel	0

	BTFSS	PIR1,TMR2IF
	GOTO	INT_END
	DECFSZ	DELAY+0,F
	GOTO	ZVUK___
	DECFSZ	DELAY+1,F
	GOTO	ZVUK___
	BSF	DELAY+2,0

ZVUK___	RRF	ZVUK,F
	BCF	CCP1CON,CCP1Y
	BTFSC	STATUS,C
	BSF	CCP1CON,CCP1Y
	RRF	ZVUK,W
	BCF	CCP1CON,CCP1X
	BTFSC	STATUS,C
	BSF	CCP1CON,CCP1X
	ANDLW	B'00111111'
	MOVWF	CCPR1L
	BCF	PIR1,TMR2IF
	
	BTFSS	ZSTATUS1,AKTIVNI	; kanal 1
	GOTO	POZVUK1
	DECF	PERIOD1+1,F
	INCF	PERIOD1+1,W
	BTFSS	STATUS,Z
	GOTO	PO_PER1
	MOVF	PERIOD1_+0,W
	ADDWF	PERIOD1+0,F
	MOVF	PERIOD1_+1,W
	BTFSC	STATUS,C
	INCFSZ	PERIOD1_+1,W
	ADDWF	PERIOD1+1,F
	MOVLW	B'00000001'
	XORWF	ZSTATUS1,F
PO_PER1	MOVF	AMPLIT1+1,W
	BTFSS	ZSTATUS1,FAZE
	MOVLW	D'0'
	MOVWF	ZVUK1
	DECFSZ	COUNTER1,F
	GOTO	POZVUK1
	MOVLW	D'64'
	MOVWF	COUNTER1
	BTFSS	ZSTATUS1,DOZVUK
	GOTO	POZVUK1
	MOVF	DOZVUK1+0,W
	SUBWF	AMPLIT1+0,F
	MOVF	DOZVUK1+1,W
	BTFSS	STATUS,C
	INCFSZ	DOZVUK1+1,W
	SUBWF	AMPLIT1+1,F
	BTFSS	STATUS,C
	BCF	ZSTATUS1,AKTIVNI
POZVUK1
	BTFSS	ZSTATUS2,AKTIVNI	; kanal 2
	GOTO	POZVUK2
	DECF	PERIOD2+1,F
	INCF	PERIOD2+1,W
	BTFSS	STATUS,Z
	GOTO	PO_PER2
	MOVF	PERIOD2_+0,W
	ADDWF	PERIOD2+0,F
	MOVF	PERIOD2_+1,W
	BTFSC	STATUS,C
	INCFSZ	PERIOD2_+1,W
	ADDWF	PERIOD2+1,F
	MOVLW	B'00000001'
	XORWF	ZSTATUS2,F
PO_PER2	MOVF	AMPLIT2+1,W
	BTFSS	ZSTATUS2,FAZE
	MOVLW	D'0'
	MOVWF	ZVUK2
	DECFSZ	COUNTER2,F
	GOTO	POZVUK2
	MOVLW	D'64'
	MOVWF	COUNTER2
	BTFSS	ZSTATUS2,DOZVUK
	GOTO	POZVUK2
	MOVF	DOZVUK2+0,W
	SUBWF	AMPLIT2+0,F
	MOVF	DOZVUK2+1,W
	BTFSS	STATUS,C
	INCFSZ	DOZVUK2+1,W
	SUBWF	AMPLIT2+1,F
	BTFSS	STATUS,C
	BCF	ZSTATUS2,AKTIVNI
POZVUK2
	BTFSS	ZSTATUS3,AKTIVNI	; kanal 2
	GOTO	POZVUK3
	DECF	PERIOD3+1,F
	INCF	PERIOD3+1,W
	BTFSS	STATUS,Z
	GOTO	PO_PER3
	MOVF	PERIOD3_+0,W
	ADDWF	PERIOD3+0,F
	MOVF	PERIOD3_+1,W
	BTFSC	STATUS,C
	INCFSZ	PERIOD3_+1,W
	ADDWF	PERIOD3+1,F
	MOVLW	B'00000001'
	XORWF	ZSTATUS3,F
PO_PER3	MOVF	AMPLIT3+1,W
	BTFSS	ZSTATUS3,FAZE
	MOVLW	D'0'
	MOVWF	ZVUK3
	DECFSZ	COUNTER3,F
	GOTO	POZVUK3
	MOVLW	D'64'
	MOVWF	COUNTER3
	BTFSS	ZSTATUS3,DOZVUK
	GOTO	POZVUK3
	MOVF	DOZVUK3+0,W
	SUBWF	AMPLIT3+0,F
	MOVF	DOZVUK3+1,W
	BTFSS	STATUS,C
	INCFSZ	DOZVUK3+1,W
	SUBWF	AMPLIT3+1,F
	BTFSS	STATUS,C
	BCF	ZSTATUS3,AKTIVNI
POZVUK3
	BTFSS	ZSTATUS4,AKTIVNI	; kanal 2
	GOTO	POZVUK4
	DECF	PERIOD4+1,F
	INCF	PERIOD4+1,W
	BTFSS	STATUS,Z
	GOTO	PO_PER4
	MOVF	PERIOD4_+0,W
	ADDWF	PERIOD4+0,F
	MOVF	PERIOD4_+1,W
	BTFSC	STATUS,C
	INCFSZ	PERIOD4_+1,W
	ADDWF	PERIOD4+1,F
	MOVLW	B'00000001'
	XORWF	ZSTATUS4,F
PO_PER4	MOVF	AMPLIT4+1,W
	BTFSS	ZSTATUS4,FAZE
	MOVLW	D'0'
	MOVWF	ZVUK4
	DECFSZ	COUNTER4,F
	GOTO	POZVUK4
	MOVLW	D'64'
	MOVWF	COUNTER4
	BTFSS	ZSTATUS4,DOZVUK
	GOTO	POZVUK4
	MOVF	DOZVUK4+0,W
	SUBWF	AMPLIT4+0,F
	MOVF	DOZVUK4+1,W
	BTFSS	STATUS,C
	INCFSZ	DOZVUK4+1,W
	SUBWF	AMPLIT4+1,F
	BTFSS	STATUS,C
	BCF	ZSTATUS4,AKTIVNI
POZVUK4

	MOVF	ZVUK1,W
	CALL	AMPLITUDA
	MOVWF	ZVUK
	MOVF	ZVUK2,W
	CALL	AMPLITUDA
	ADDWF	ZVUK,F
	MOVLW	D'255'
	BTFSC	STATUS,C
	MOVWF	ZVUK
	MOVF	ZVUK3,W
	CALL	AMPLITUDA
	ADDWF	ZVUK,F
	MOVLW	D'255'
	BTFSC	STATUS,C
	MOVWF	ZVUK
	MOVF	ZVUK4,W
	CALL	AMPLITUDA
	ADDWF	ZVUK,F
	MOVLW	D'255'
	BTFSC	STATUS,C
	MOVWF	ZVUK

INT_END	MOVF	ST_TEMP,W
	MOVWF	STATUS
	SWAPF	W_TEMP,F
	SWAPF	W_TEMP,W
	RETFIE 

START	
	banksel	TRISC
	BCF	TRISC,2
	banksel	T2CON
	MOVLW	B'00011100'
	MOVWF	T2CON
	banksel	PR2
	MOVLW	D'63'
	MOVWF	PR2
	banksel	0
	CLRF	TMR2
	CLRF	CCPR1L
	MOVLW	B'00001100'
	MOVWF	CCP1CON

	CLRF	ZVUK1
	CLRF	ZVUK2
	CLRF	ZVUK3
	CLRF	ZVUK4
	BCF	ZSTATUS1,AKTIVNI
	BCF	ZSTATUS2,AKTIVNI
	BCF	ZSTATUS3,AKTIVNI
	BCF	ZSTATUS4,AKTIVNI
	BSF	ZSTATUS1,DOZVUK
	BSF	ZSTATUS2,DOZVUK
	BSF	ZSTATUS3,DOZVUK
	BSF	ZSTATUS4,DOZVUK

	banksel	PIE1
	BSF	PIE1,TMR2IE
	banksel	0
	BSF	INTCON,PEIE
	BSF	INTCON,GIE

	MOVLW	D'0'
	TABFIND	HUDBY
	BSF	DELAY+2,0
LOOP	BTFSS	DELAY+2,0
	GOTO	$ - 1
	BCF	DELAY+2,0
	CALL	CTI_CAS
	MOVF	TEMP+1,W
	IORWF	TEMP+0,W
	BTFSC	STATUS,Z
	GOTO	MUS_END
	BCF	INTCON,GIE
	BTFSC	INTCON,GIE
	GOTO	$ - 2
	MOVF	TEMP+0,W
	MOVWF	DELAY+0
	MOVF	TEMP+1,W
	MOVWF	DELAY+1
	BSF	INTCON,GIE

	BTFSS	NEAKTIV,0
	GOTO	$ + 3
	BCF	ZSTATUS1,AKTIVNI
	CLRF	ZVUK1
	BTFSS	AKTIV,0
	GOTO	DALSI_1
	CALL	CTI_TON
	EADR_PUSH EADR_TEMP
	MOVF	TON_,W
	CALL	GETTON
	MOVF	TEMP+0,W
	MOVWF	PERIOD1_+0
	MOVF	TEMP+1,W
	MOVWF	PERIOD1_+1
	MOVF	HLASIT_,W
	CALL	GETHLASIT
	MOVF	TEMP+0,W
	MOVWF	AMPLIT1+1
	MOVLW	D'255'
	MOVWF	AMPLIT1+0
	MOVF	DOZVUK_,W
	CALL	GETDOZVUK
	MOVF	TEMP+0,W
	MOVWF	DOZVUK1+0
	MOVF	TEMP+1,W
	MOVWF	DOZVUK1+1
	BSF	ZSTATUS1,AKTIVNI
	EADR_POP	EADR_TEMP
DALSI_1	BTFSS	NEAKTIV,1
	GOTO	$ + 3
	BCF	ZSTATUS2,AKTIVNI
	CLRF	ZVUK2
	BTFSS	AKTIV,1
	GOTO	DALSI_2
	CALL	CTI_TON
	EADR_PUSH EADR_TEMP
	MOVF	TON_,W
	CALL	GETTON
	MOVF	TEMP+0,W
	MOVWF	PERIOD2_+0
	MOVF	TEMP+1,W
	MOVWF	PERIOD2_+1
	MOVF	HLASIT_,W
	CALL	GETHLASIT
	MOVF	TEMP+0,W
	MOVWF	AMPLIT2+1
	MOVLW	D'255'
	MOVWF	AMPLIT2+0
	MOVF	DOZVUK_,W
	CALL	GETDOZVUK
	MOVF	TEMP+0,W
	MOVWF	DOZVUK2+0
	MOVF	TEMP+1,W
	MOVWF	DOZVUK2+1
	BSF	ZSTATUS2,AKTIVNI
	EADR_POP	EADR_TEMP
DALSI_2	BTFSS	NEAKTIV,2
	GOTO	$ + 3
	BCF	ZSTATUS3,AKTIVNI
	CLRF	ZVUK3
	BTFSS	AKTIV,2
	GOTO	DALSI_3
	CALL	CTI_TON
	EADR_PUSH EADR_TEMP
	MOVF	TON_,W
	CALL	GETTON
	MOVF	TEMP+0,W
	MOVWF	PERIOD3_+0
	MOVF	TEMP+1,W
	MOVWF	PERIOD3_+1
	MOVF	HLASIT_,W
	CALL	GETHLASIT
	MOVF	TEMP+0,W
	MOVWF	AMPLIT3+1
	MOVLW	D'255'
	MOVWF	AMPLIT3+0
	MOVF	DOZVUK_,W
	CALL	GETDOZVUK
	MOVF	TEMP+0,W
	MOVWF	DOZVUK3+0
	MOVF	TEMP+1,W
	MOVWF	DOZVUK3+1
	BSF	ZSTATUS3,AKTIVNI
	EADR_POP	EADR_TEMP
DALSI_3	BTFSS	NEAKTIV,3
	GOTO	$ + 3
	BCF	ZSTATUS4,AKTIVNI
	CLRF	ZVUK4
	BTFSS	AKTIV,3
	GOTO	DALSI_4
	CALL	CTI_TON
	EADR_PUSH EADR_TEMP
	MOVF	TON_,W
	CALL	GETTON
	MOVF	TEMP+0,W
	MOVWF	PERIOD4_+0
	MOVF	TEMP+1,W
	MOVWF	PERIOD4_+1
	MOVF	HLASIT_,W
	CALL	GETHLASIT
	MOVF	TEMP+0,W
	MOVWF	AMPLIT4+1
	MOVLW	D'255'
	MOVWF	AMPLIT4+0
	MOVF	DOZVUK_,W
	CALL	GETDOZVUK
	MOVF	TEMP+0,W
	MOVWF	DOZVUK4+0
	MOVF	TEMP+1,W
	MOVWF	DOZVUK4+1
	BSF	ZSTATUS4,AKTIVNI
	EADR_POP	EADR_TEMP
DALSI_4	GOTO	LOOP

MUS_END	GOTO	$

CTI_CAS	NEXTREAD
	banksel	EEDATA
	MOVF	EEDATA,W
	banksel	AKTIV
	ANDLW	B'00001111'
	MOVWF	AKTIV
	banksel	EEDATA
	SWAPF	EEDATA,W
	banksel	NEAKTIV
	ANDLW	B'00001111'
	MOVWF	NEAKTIV
	EADR_PUSH	EADR_TEMP
	banksel	EEDATH
	MOVF	EEDATH,W
	CALL	GETCAS
	EADR_POP	EADR_TEMP
	RETURN

CTI_TON	NEXTREAD
	banksel	EEDATA
	MOVF	EEDATA,W
	banksel	TON_
	MOVWF	TON_
	banksel	EEDATH
	MOVF	EEDATH,W
	banksel	HLASIT_
	ANDLW	B'00000111'
	MOVWF	HLASIT_
	banksel	EEDATH
	RRF	EEDATH,F
	RRF	EEDATH,F
	RRF	EEDATH,W
	banksel	DOZVUK_
	ANDLW	B'00000111'
	MOVWF	DOZVUK_
	RETURN

CTENI	
	banksel	EECON1		; cteni z FLASH
	BSF	EECON1,EEPGD
	BSF	EECON1,RD
	NOP
	NOP
	BCF	STATUS,C
	banksel	EEDATA
	RLF	EEDATA,W
	banksel	TEMP+0
	MOVWF	TEMP+0
	banksel	EEDATH
	RLF	EEDATH,W
	banksel	TEMP+1
	MOVWF	TEMP+1
	RETURN

GETCAS	
	banksel	EECON1
	BTFSC	EECON1,WR
	GOTO	$ - 1
	banksel	EEADR		; TONY + W -> (EEADRH:EEADRL)
	ADDLW	CASY % D'256'
	MOVWF	EEADR
	MOVLW	CASY / D'256'
	BTFSC	STATUS,C
	ADDLW	D'1'
	MOVWF	EEADRH
	CALL	CTENI
	RLF	TEMP+0,F
	RLF	TEMP+1,F
	RETURN

GETTON	
	banksel	EECON1
	BTFSC	EECON1,WR
	GOTO	$ - 1
	banksel	EEADR		; TONY + W -> (EEADRH:EEADRL)
	ADDLW	TONY % D'256'
	MOVWF	EEADR
	MOVLW	TONY / D'256'
	BTFSC	STATUS,C
	ADDLW	D'1'
	MOVWF	EEADRH
	CALL	CTENI
	RLF	TEMP+0,F
	RLF	TEMP+1,F
	RETURN

GETDOZVUK
	banksel	EECON1
	BTFSC	EECON1,WR
	GOTO	$ - 1
	banksel	EEADR		; DOZVUKY + W -> (EEADRH:EEADRL)
	ADDLW	DOZVUKY % D'256'
	MOVWF	EEADR
	MOVLW	DOZVUKY / D'256'
	BTFSC	STATUS,C
	ADDLW	D'1'
	MOVWF	EEADRH
	CALL	CTENI
	RRF	TEMP+1,F
	RRF	TEMP+0,F
	RETURN

GETHLASIT
	banksel	EECON1
	BTFSC	EECON1,WR
	GOTO	$ - 1
	banksel	EEADR		; DOZVUKY + W -> (EEADRH:EEADRL)
	ADDLW	HLASITOST % D'256'
	MOVWF	EEADR
	MOVLW	HLASITOST / D'256'
	BTFSC	STATUS,C
	ADDLW	D'1'
	MOVWF	EEADRH
	CALL	CTENI
	RRF	TEMP+1,F
	RRF	TEMP+0,F
	RETURN

;---------------------------------------
; amplitudy dozvuku
AMPLITUDA	MOVWF	WTABTEMP
	MOVLW	AMPLDATA / H'100'
	MOVWF	PCLATH
	MOVLW	AMPLDATA % H'100'
	ADDWF	WTABTEMP,W
	BTFSC	STATUS,C
	INCF	PCLATH,F
	MOVWF	PCL
AMPLDATA
	include	ampldata.inc

;---------------------------------------
; periody vybranych tonu
TONY	
	include	tony.inc

;---------------------------------------
; delky not (respektive casovani znacek)
CASY
	include	casy.inc

;---------------------------------------
; preddefinovane delky dozvuku
DOZVUKY
	include	dozvuky.inc

;---------------------------------------
; preddefinovane hlasitosti
HLASITOST	
	include	hlasit.inc

;--------------------------------------
; SKLADBY
HUDBY	DATA	MOZART

MOZART	
	include	mozart.inc	

	END
